;===============================================================================
;       Mosaic.asm
;===============================================================================
.486
.model      flat, stdcall
option      casemap: none

includelib  \masm32\lib\kernel32.lib
includelib  \masm32\lib\user32.lib
includelib  \masm32\lib\gdi32.lib
includelib  \masm32\lib\comctl32.lib
includelib  \masm32\lib\comdlg32.lib
include     \masm32\include\kernel32.inc
include     \masm32\include\comctl32.inc
include     \masm32\include\comdlg32.inc
include     \masm32\include\user32.inc
include     \masm32\include\gdi32.inc
include     \masm32\include\windows.inc
include     mosaic.inc
WinMain     	 	PROTO STDCALL  	:DWORD, :DWORD, :DWORD, :DWORD
WndProc     	 	PROTO STDCALL 	:DWORD, :DWORD, :DWORD, :DWORD
InitControls	 	PROTO STDCALL	:DWORD
InitBitmaps		 	PROTO STDCALL 	:DWORD
DeleteBitmaps	 	PROTO STDCALL
SetBitmap		 	PROTO STDCALL 	:DWORD, :DWORD
GetCoordinates	 	PROTO STDCALL 	:DWORD
DrawNumbers		 	PROTO STDCALL
CreateTiles		 	PROTO STDCALL
DrawProc		 	PROTO STDCALL 	:DWORD, :DWORD
InitGame		 	PROTO STDCALL 	:DWORD
NewGame			 	PROTO STDCALL	:DWORD
ProcessClick	 	PROTO STDCALL	:DWORD, :DWORD
GetPosOf		 	PROTO STDCALL 	:DWORD, :DWORD, :DWORD
GetTile			 	PROTO STDCALL 	:DWORD
ProcessMenuItems 	PROTO STDCALL  	:DWORD, :DWORD
SetColors		 	PROTO STDCALL  	:DWORD
CheckIfValidBitmap  PROTO STDCALL 	:DWORD, :DWORD, :DWORD
OpenBitmap			PROTO STDCALL   :DWORD
.data
AppName             db      "Mosaic",0
ClassName           db      "Mosaic32",0
DefaultStatusText   db      "Mosaic 1.0",0 
ClassStatic			db		"STATIC",0
StatusParts			dd		90,90+80,-1

NumberFormat		db		"%lu",0
Rect200				RECT	<0,0,200,200>
Rect220 			RECT 	<0,0,220,220>
RectUpdate			RECT	<15,55,15+220,55+220>
FontFace			db		"Arial",0

TilePositions		dw		0,0			; tile 1
					dw		50,0		; tile 2
					dw		100,0		; tile 3
					dw		150,0		; tile 4
					dw		0,50		; tile 5
					dw		50,50		; tile 6
					dw		100,50		; tile 7
					dw		150,50		; tile 8
					dw		0,100		; tile 9
					dw		50,100		; tile 10
					dw		100,100		; tile 11
					dw		150,100		; tile 12
					dw		0,150		; tile 13
					dw		50,150		; tile 14
					dw		100,150		; tile 15
					dw		150,150		; tile 16
OFN_Filter			db		"Bitmaps (*.bmp)",0,"*.bmp",0,"All Files (*.*)",0,"*.*",0,0

BitmapOFN		OPENFILENAME	<SIZEOF OPENFILENAME,\
								NULL,\
								NULL,\
								offset OFN_Filter,\
								NULL, NULL, NULL, offset OFN_file,\
								270,\
								NULL, NULL, NULL, NULL,\
								OFN_PATHMUSTEXIST + OFN_FILEMUSTEXIST,\
								NULL, NULL, NULL, NULL, NULL, NULL>
.data?
hInstance       	dd      ?
hMenu           	dd      ?
hStatic				dd		?
hToolbar			dd		?
hStatus       		dd      ?

BackBufferDC		dd	?
hBackBuffer			dd	?
ImageDC				dd	?
hImage				dd	?
hBackgroundColor	dd	?
hTileColor			dd	?
hFont				dd	?
TextColor			dd	?
CurImageType		dd	?		
Buffer				db	200 dup (?)
Difficulty			dd	?
CurrentBlankPos		dd	?
OFN_file			db	270 dup (?)
TileTable			db	16 dup (?)
.data
ToolbarButtons	TBBUTTON	<0, MI_OPENBITMAP, TBSTATE_ENABLED	, TBSTYLE_BUTTON,0, NULL, NULL> 
				TBBUTTON	<1, MI_NEWGAME, TBSTATE_ENABLED	, TBSTYLE_BUTTON,0, NULL, NULL>
				
				TBBUTTON	<NULL, NULL, NULL, TBSTYLE_SEP, NULL, NULL>;--- seperator
				
				TBBUTTON	<2, MI_USESTANDARD, TBSTATE_ENABLED	+TBSTATE_CHECKED, TBSTYLE_CHECKGROUP,0, NULL, NULL>
				TBBUTTON	<3, MI_USENUMBERS, TBSTATE_ENABLED	, TBSTYLE_CHECKGROUP,0, NULL, NULL>
				TBBUTTON	<4, MI_USEFILE, TBSTATE_ENABLED	, TBSTYLE_CHECKGROUP,0, NULL, NULL>
				
				TBBUTTON	<NULL, NULL, NULL, TBSTYLE_SEP, NULL, NULL>;--- seperator
				
				TBBUTTON	<5, MI_ABOUT, TBSTATE_ENABLED, TBSTYLE_BUTTON,0, NULL, NULL>


.code
    start:
    ; Get module handle and save it
    invoke  GetModuleHandle, NULL
    mov     hInstance, eax
    
    ; Init Common Controls library
    invoke  InitCommonControls
    
    ; Run winmain procedure and exit program
    invoke  WinMain, hInstance, NULL, NULL, SW_SHOWNORMAL
    invoke  ExitProcess,eax

;===============================================================================
; WinMain
;===============================================================================
WinMain proc hInst:HINSTANCE,hPrevInst:HINSTANCE,CmdLine:LPSTR,CmdShow:DWORD
LOCAL wc:WNDCLASSEX
LOCAL msg:MSG
LOCAL hwnd:HWND
    mov     wc.cbSize,SIZEOF WNDCLASSEX
    mov     wc.style, CS_HREDRAW or CS_VREDRAW
    mov     wc.lpfnWndProc, OFFSET WndProc
    mov     wc.cbClsExtra,NULL
    mov     wc.cbWndExtra,NULL
    push    hInstance
    pop     wc.hInstance
    mov     wc.hbrBackground,COLOR_WINDOW
    mov     wc.lpszMenuName, NULL
    mov     wc.lpszClassName,OFFSET ClassName
    invoke  LoadIcon, hInstance, ICON1_BIG
    mov     wc.hIcon, eax
    invoke  LoadIcon, hInstance, ICON2_SMALL
    mov     wc.hIconSm, eax
    invoke  LoadCursor,NULL,IDC_ARROW
    mov     wc.hCursor,eax
    invoke  RegisterClassEx, addr wc
    invoke  LoadMenu, hInstance, MAINMENU ;load menu
    mov     hMenu, eax                    ;store handle
    INVOKE  CreateWindowEx,NULL,ADDR ClassName,ADDR AppName,\
            WS_OVERLAPPEDWINDOW-WS_MAXIMIZEBOX-WS_SIZEBOX,\
            CW_USEDEFAULT, CW_USEDEFAULT,258,350,NULL,hMenu,\
            hInst,NULL
    mov     hwnd,eax
    invoke  ShowWindow, hwnd, CmdShow
    invoke  UpdateWindow, hwnd
    .WHILE  TRUE
        invoke  GetMessage, ADDR msg,NULL,0,0
        .BREAK  .IF (!eax)
        invoke  TranslateMessage, ADDR msg
        invoke  DispatchMessage, ADDR msg
    .ENDW
    mov     eax,msg.wParam
    ret
WinMain endp



    
;===============================================================================
;   Window procedure
;===============================================================================    
WndProc proc    hWnd:DWORD, uMsg:DWORD, wParam:DWORD, lParam:DWORD
mov eax, uMsg
    .IF     eax==WM_CREATE
       	invoke	InitControls, hWnd
       	invoke	InitBitmaps, hWnd
       	invoke	InitGame, hWnd
       	invoke	ProcessMenuItems, hWnd, MI_EASY
		invoke	ProcessMenuItems, hWnd, MI_USENUMBERS
		invoke	ProcessMenuItems, hWnd, MI_COLORBLUE
       	invoke	NewGame, hWnd		;TEMPORARY LINE!!!!!!
    .ELSEIF eax==WM_DRAWITEM
		mov		eax, wParam
		.IF		eax==CID_STATIC
			push	ebx
			mov		ebx, lParam
			assume	ebx:ptr DRAWITEMSTRUCT
			invoke	DrawProc, hWnd, [ebx].hdc
			assume	ebx:nothing
			pop		ebx
			xor		eax, eax
			inc		eax
		.ELSE
			xor 	eax, eax
		.ENDIF
	.ELSEIF eax==WM_COMMAND
		mov 	eax, wParam
		shr 	ax, 16
		.IF		ax==0 ; menu notification
			invoke	ProcessMenuItems, hWnd, wParam
		.ENDIF
	.ELSEIF eax==WM_LBUTTONDOWN
		mov		eax, lParam
		and		eax, 0ffffh
		mov		ecx, lParam
		shr		ecx, 16

		invoke	ChildWindowFromPoint, hWnd, eax,ecx
		.IF		eax==hStatic		; clicked in static window?
			invoke	ProcessClick, hWnd, lParam
		.ENDIF
    .ELSEIF eax==WM_DESTROY
        invoke  PostQuitMessage, NULL
    .ELSE
        invoke  DefWindowProc,hWnd,uMsg,wParam,lParam       
        ret
    .ENDIF
ret
WndProc endp

;================================================================================
;                           Init Controls
;================================================================================
InitControls proc hWnd:DWORD
LOCAL DefaultFont:DWORD
	;--- Create static window for mosaic: ---
    invoke  CreateWindowEx, WS_EX_CLIENTEDGE, ADDR ClassStatic, NULL,\
            WS_VISIBLE + WS_CHILD + SS_OWNERDRAW    ,\
            15, 55, 220, 220,\
            hWnd, CID_STATIC, hInstance, NULL
    mov     hStatic, eax
    
    
    ;--- save default font ---
    invoke  GetStockObject, DEFAULT_GUI_FONT
    mov     DefaultFont, eax
    
    ;--- create the toolbar window ---
   	invoke	CreateToolbarEx, hWnd, WS_CHILD + WS_VISIBLE + TBSTYLE_FLAT + WS_BORDER,\
			CID_TOOLBAR, 6, hInstance, BMP_TOOLBAR, ADDR ToolbarButtons,\
			8, 32, 32, 32, 32, SIZEOF TBBUTTON
	mov		hToolbar, eax
	invoke	SendMessage, eax, TB_AUTOSIZE, NULL, NULL 

    ; Create statusbar window:
    invoke  CreateStatusWindow, WS_CHILD + WS_VISIBLE,\
             ADDR DefaultStatusText, hWnd, CID_STATUS
    mov     hStatus, eax
    invoke  SendMessage, hStatus, WM_SETFONT, DefaultFont, TRUE 
    invoke  SendMessage, hStatus, SB_SETPARTS,3, ADDR StatusParts
    
ret
InitControls endp



;================================================================================
;							Init Bitmaps
;================================================================================
InitBitmaps proc hWnd:DWORD
; Create DC's for backbuffer and current image
	invoke 	CreateCompatibleDC, NULL
	mov		BackBufferDC, eax
	
	invoke	CreateCompatibleDC, NULL
	mov		ImageDC, eax

; Create bitmap for backbuffer:
	invoke	GetDC, hWnd
	push 	eax
	invoke	CreateCompatibleBitmap, eax, 200+20,200+20
	mov		hBackBuffer, eax
	pop		eax
	invoke	ReleaseDC, hWnd, eax
	invoke	SelectObject, BackBufferDC, hBackBuffer
	
; Create Arial font for the numbers	
	invoke	CreateFont, -30, NULL, NULL, NULL, FW_EXTRABOLD, \
			FALSE, FALSE, FALSE, NULL, NULL, NULL, NULL, NULL, ADDR FontFace
	mov		hFont, eax

; Select font in Image DC
   invoke	SelectObject, ImageDC, hFont

   invoke	CreateSolidBrush, 0FF8000h
   mov		hBackgroundColor, eax
   invoke	CreateSolidBrush, 0FF8080h
   mov		hTileColor, eax
   
   mov		TextColor, 0800000h
ret
InitBitmaps endp

;================================================================================
;							Delete Bitmaps
;================================================================================
DeleteBitmaps proc
	invoke	DeleteDC, BackBufferDC
	invoke	DeleteDC, ImageDC
	invoke	DeleteObject, hImage
	invoke	DeleteObject, hBackBuffer
	invoke	DeleteObject, hFont
	invoke	DeleteObject, hBackgroundColor
	invoke	DeleteObject, hTileColor
ret
DeleteBitmaps endp

;================================================================================
;							Set Bitmap
;================================================================================
SetBitmap	proc hWnd:DWORD, ImageType:DWORD
	mov 	eax, ImageType
	.IF	eax==IMAGETYPE_NUMBERS
		;--- delete old image ---
		invoke	DeleteObject, hImage
		;--- Get DC ---
		invoke	GetDC, hWnd
		push 	eax
		;--- Create new bitmap for the numbers bitmap ---
		invoke	CreateCompatibleBitmap, eax, 200, 200
		mov		hImage, eax
		pop		eax
		;--- Release DC ---
		invoke	ReleaseDC, hWnd, eax
		;--- Select new bitmap in DC ---
		invoke	SelectObject, ImageDC, hImage
		;--- Draw numbers on the bitmap ---
		invoke	DrawNumbers
		;--- Create the 3D effect on the bitmap ---
		invoke	CreateTiles
	.ELSEIF 	eax==IMAGETYPE_STANDARD
		;--- delete old image ---
		invoke	DeleteObject, hImage
		;--- load bitmap from resource ---
		invoke	LoadBitmap, hInstance, BMP_DEMOBITMAP
		;--- save new handle ---
		mov		hImage, eax
		;--- select new handle in ImageDC ---
		invoke	SelectObject, ImageDC, eax
		;--- Create the 3D effect on the bitmap
		invoke	CreateTiles
	.ELSEIF	eax==IMAGETYPE_BITMAP
		invoke	SelectObject, ImageDC, hImage
		invoke	CreateTiles
	.ENDIF
	;--- Set the new image type ---
	mov		eax, ImageType
	mov		CurImageType, eax
ret
SetBitmap	endp



;================================================================================
;							Draw Numbers
;================================================================================
DrawNumbers proc uses ebx edi
LOCAL	TempRect:RECT
	; --- Set the textcolor of ImageDC to TextColor ---
	invoke	SetTextColor, ImageDC, TextColor
	; --- Fill the imageDC with the tile color brush ---
	invoke	FillRect, ImageDC, ADDR Rect200, hTileColor
	; --- Set the background mode to transparent (for the text) ---
	invoke	SetBkMode, ImageDC, TRANSPARENT
	
	; --- Loop through all the numbers and draw them one by one ---
	xor		ebx, ebx
	.WHILE	ebx<16
		mov		eax, ebx
		inc		eax
		invoke	GetCoordinates, eax
		mov		dx, ax		; dx  = row
		shr		eax, 16 	; ax  = column
		and		edx, 0ffffh	; make sure that edx = dx
		imul	edx, edx, 50;} Multipy edx as well as eax with 50
		imul	eax, 50		;} 
		mov		TempRect.left, eax
		mov		TempRect.top, edx
		add		eax, 50
		add		edx, 50
		mov		TempRect.right, eax
		mov		TempRect.bottom, edx
		mov		eax, ebx
		inc		eax
		invoke	wsprintf, ADDR Buffer, ADDR NumberFormat, eax
		invoke	DrawText, ImageDC, ADDR Buffer, -1, ADDR TempRect,\
				DT_CENTER or DT_SINGLELINE or DT_VCENTER
	inc ebx
	.ENDW
ret
DrawNumbers endp

;================================================================================
;							GetCoordinates
;================================================================================
GetCoordinates proc	dwTile:DWORD
	mov		eax, dwTile
	dec		eax
	cdq
	mov		ecx, 4
	div		ecx
	;eax=quotient = row
	;edx=remainder = column
	shl 	edx, 16
	add		eax, edx
ret
GetCoordinates endp

;================================================================================
;							Create Tiles
;================================================================================
CreateTiles proc uses ebx esi edi
	invoke	GetStockObject, BLACK_PEN
	invoke	SelectObject, ImageDC, eax
; Dark lines, vertical. x = 50k - 1 (k=1,2,3,4)
; ebx = k
; esi = x
	xor 	ebx, ebx	
	inc		ebx	
	; ebx is 1 now
	
	.WHILE	ebx<5 	; (ebx= 1,2,3,4)
		mov		eax, 50
		mul		ebx
		mov		esi, eax
		dec		esi
		invoke	MoveToEx, ImageDC, esi, 0, NULL
		invoke	LineTo, ImageDC, esi, 199
	inc ebx
	.ENDW

; Dark lines, horizontal. y = 50k - 1 (k=1,2,3,4)
; ebx = k
; esi = y
	xor 	ebx, ebx	
	inc		ebx	
	; ebx is 1 now
	.WHILE	ebx<5 	; (ebx= 1,2,3,4)
		mov		eax, 50
		mul		ebx
		mov		esi, eax
		dec		esi
		invoke	MoveToEx, ImageDC, 0, esi, NULL
		invoke	LineTo, ImageDC, 199, esi
	inc	ebx
	.ENDW
	invoke	GetStockObject, WHITE_PEN
	invoke	SelectObject, ImageDC, eax
; Light lines, vertical. x = 50k  (k=0,1,2,3)
; ebx = k
; esi = x
	xor 	ebx, ebx	

	.WHILE	ebx<4 	; (ebx= 0,1,2,3)
		mov		eax, 50
		mul		ebx
		mov		esi, eax
		invoke	MoveToEx, ImageDC, esi, 0, NULL
		invoke	LineTo, ImageDC, esi, 199
	inc ebx
	.ENDW

; Light lines, horizontal. y = 50k (k=0,1,2,3)
; ebx = k
; esi = y
	xor 	ebx, ebx	

	; ebx is 1 now
	
	.WHILE	ebx<4 	; (ebx= 0,1,2,3)
		mov		eax, 50
		mul		ebx
		mov		esi, eax
		invoke	MoveToEx, ImageDC, 0, esi, NULL
		invoke	LineTo, ImageDC, 199, esi
	inc	ebx
	.ENDW
	
ret
CreateTiles endp

;================================================================================
;							Draw Numbers
;================================================================================
DrawProc proc uses ebx edi esi hWnd:DWORD, hDC:DWORD
	; Blank the backbuffer with the background color brush:
	invoke	FillRect, BackBufferDC, ADDR Rect220, hBackgroundColor
	
	;Loop:
	xor		ebx, ebx
	.WHILE	ebx<16
		;Get the tile that is at tilepos ebx
		xor		ecx, ecx
		mov		cl, byte ptr [offset TileTable + ebx]
		.IF 	ecx==NULL	;tile = 0 means blank space
			jmp		@blankspace_skip
		.ENDIF
		dec		ecx	; decrease number (tables are 0-based, tile numbers 1-based)
		;Get the coordinates of that tile:
		shl		ecx, 2		;multiply tilenr-1 by 4
		mov		eax, dword ptr [offset TilePositions + ecx]
		; The high word of eax is the X coordinate, the low word the y coordinate
		
		mov		cx, ax		;ecx = source y
		shr		eax, 16		;eax = source x
		
		;Get coordinates of tile pos ebx
		mov		edx, ebx
		shl		edx, 2
		mov		edx, dword ptr [offset TilePositions + edx]
			
		xor		edi, edi
		mov		di, dx		;edi=destination y
		shr		edx, 16		;edx=destination x
		
		add		edx, 9		;margin (vertical)
		add		edi, 9		;margin (horizontal)
		invoke	BitBlt, BackBufferDC, edi, edx, 50, 50, ImageDC, ecx, eax, SRCCOPY
@blankspace_skip:
	inc ebx		
	.ENDW
	; Copy the backbuffer onto the control
	invoke	BitBlt, hDC, 0, 0, 220, 220, BackBufferDC, 0, 0, SRCCOPY
ret
DrawProc endp

;================================================================================
;							InitGame
;================================================================================
InitGame	proc	hWnd:DWORD
	mov		eax, offset TileTable
	mov		dword ptr [eax], 	 04030201h
	mov		dword ptr [eax+04h], 08070605h
	mov		dword ptr [eax+08h], 0C0B0A09h
	mov		dword ptr [eax+0Ch], 100F0E0Dh
	invoke	SetBitmap, hWnd, IMAGETYPE_NUMBERS
ret
InitGame	endp


;================================================================================
;							New Game
;================================================================================
NewGame		proc	hWnd:DWORD
; Set initial tile positions:
; not that the last index is 0, this is the blank space
	mov		eax, offset TileTable
	mov		dword ptr [eax], 	 04030201h
	mov		dword ptr [eax+04h], 08070605h
	mov		dword ptr [eax+08h], 0C0B0A09h
	mov		dword ptr [eax+0Ch], 000F0E0Dh
	
	mov		CurrentBlankPos, 16
	invoke	InvalidateRect, hWnd, NULL, FALSE
ret
NewGame		endp

;================================================================================
;							ProcessClick
;================================================================================
ProcessClick	proc	uses ebx hWnd:DWORD, Pos:DWORD
LOCAL TempRect:RECT
LOCAL DestPoint:POINT
LOCAL TileCoords:POINT
	
	; --- get the border width of the static control ---
	invoke	GetClientRect, hStatic, ADDR TempRect
	mov		eax, TempRect.bottom
	mov		edx, 220
	sub		edx, eax
	shr		edx, 1	;edx contains the border width now
	
	; --- extract the X and Y coordinates from Pos ---
	mov		eax, Pos
	mov		ecx, Pos
	shr		ecx, 16		; ecx = Y (high word of pos)
	and		eax, 0ffffh ; eax = X (low word of pos)
	
	; The static control is at (15, 55, 220, 220). The X and Y coordinates
	; (eax and ecx) are relative to the main window, not the static control.
	; First, the coordinates of the control are substracted from X and Y
	; (eax=eax-15, ecx=ecx-55), then the border width (edx) of the control has to
	; be substracted from X and T(eax=eax-edx, ecx=ecx-edx)
	
	sub		eax, 15
	sub		ecx, 55
	sub		eax, edx
	sub		ecx, edx
	
	; The left and top margin is 9 pixels
	; Check if clicked on one of the tiles (
	; this is true if 9<x<(200+9) and 9<y<(200+9)
	.IF		eax>8 && eax<50*4+9
		.IF ecx>8 && ecx<50*4+9
			; Get coordinates of tile clicked on (coordinates 0,1,2,3)
			sub		eax, 9
			sub		ecx, 9
			mov		ebx, 50
			cdq
			div		ebx
			mov		TileCoords.x, eax
			mov		eax, ecx
			cdq
			div		ebx
			mov		TileCoords.y, eax
			; coordinates are now in TileCoords
			
			; now look if it can be moved:
			xor		ebx, ebx
			.WHILE	ebx<4 ;tile_above, left etc.
				invoke	GetPosOf, ADDR TileCoords, ADDR DestPoint, ebx
				invoke	GetTile,  ADDR DestPoint
				.IF		eax!=NULL
					dec		eax
					mov		edx, eax
					mov		cl, byte ptr [offset TileTable + eax]
					
					; cl = tile at that pos
					.IF		cl==NULL
						push 	edx
						invoke	GetTile, ADDR TileCoords
						mov		ecx, eax
						dec		ecx
						mov		al, byte ptr [offset TileTable + ecx]
						mov		byte ptr [offset TileTable + ecx],0
						pop		edx
						mov		byte ptr [offset TileTable + edx], al
						.BREAK
					.ENDIF
				.ENDIF
			inc ebx
			.ENDW
			
		.ENDIF
	.ENDIF
	invoke	InvalidateRect, hWnd, ADDR RectUpdate, FALSE
ret
ProcessClick	endp

;================================================================================
;							GetPosOf
;================================================================================
GetPosOf proc	lpPoint:DWORD, lpPointDest:DWORD,dwType:DWORD
	mov		edx, lpPoint
	mov		ecx, lpPointDest
	assume	edx:ptr POINT
	assume	ecx:ptr POINT
	push	[edx].x
	push	[edx].y
	pop		[ecx].y
	pop		[ecx].x
	.IF		dwType==TILE_ABOVE
		dec		[ecx].y
	.ELSEIF dwType==TILE_BELOW
		inc		[ecx].y
	.ELSEIF dwType==TILE_LEFT
		dec 	[ecx].x
	.ELSEIF dwType==TILE_RIGHT
		inc		[ecx].x
	.ENDIF
	assume	edx:nothing
	assume	ecx:nothing
ret
GetPosOf endp

;================================================================================
;							GetTile
;================================================================================
GetTile proc	lpPoint:DWORD
	mov		eax, lpPoint
	assume	eax:ptr POINT
	mov		ecx, [eax].x
	cmp		ecx, 3
	jg		gt_invalid
	cmp		ecx, 0
	jl		gt_invalid
	mov		edx, [eax].y
	cmp		edx, 3
	jg		gt_invalid
	cmp		edx, 0
	jl		gt_invalid
	shl		edx, 2		;multiply by 4
	add		edx, ecx
	assume	eax:nothing
	mov		eax, edx
	inc		eax
ret
gt_invalid:
	xor eax, eax
ret
GetTile endp

ProcessMenuItems proc hWnd:DWORD, wParam:DWORD
mov		eax, wParam
;-------------------------------------------------------------------------------
; Difficuly
;-------------------------------------------------------------------------------
.IF	ax==MI_MEDIUM
	invoke	CheckMenuItem, hMenu, MI_EASY, MF_UNCHECKED
	invoke	CheckMenuItem, hMenu, MI_HARD, MF_UNCHECKED
	invoke	CheckMenuItem, hMenu, MI_MEDIUM, MF_CHECKED
	mov		Difficulty, MEDIUM
.ELSEIF ax==MI_EASY
	invoke	CheckMenuItem, hMenu, MI_EASY, MF_CHECKED
	invoke	CheckMenuItem, hMenu, MI_HARD, MF_UNCHECKED
	invoke	CheckMenuItem, hMenu, MI_MEDIUM, MF_UNCHECKED
	mov		Difficulty, EASY
.ELSEIF ax==MI_HARD
	invoke	CheckMenuItem, hMenu, MI_EASY, MF_UNCHECKED
	invoke	CheckMenuItem, hMenu, MI_HARD, MF_CHECKED
	invoke	CheckMenuItem, hMenu, MI_MEDIUM, MF_UNCHECKED
	mov		Difficulty, HARD
;-------------------------------------------------------------------------------
; Image type
;-------------------------------------------------------------------------------
.ELSEIF ax==MI_USEFILE		
	invoke	CheckMenuItem, hMenu, MI_USEFILE, MF_CHECKED
	invoke	CheckMenuItem, hMenu, MI_USENUMBERS, MF_UNCHECKED
	invoke	CheckMenuItem, hMenu, MI_USESTANDARD, MF_UNCHECKED
	invoke	SendMessage, hToolbar, TB_CHECKBUTTON, MI_USEFILE, TRUE
	mov		eax, offset OFN_file
	mov		al, byte ptr [eax]
	.IF		al==NULL
		invoke	GetOpenFileName, ADDR BitmapOFN
	.ENDIF
	.IF		eax!=NULL
		invoke	OpenBitmap, hWnd
		invoke	SetBitmap, hWnd, IMAGETYPE_BITMAP
		invoke	InvalidateRect, hWnd, NULL, FALSE	
	.ENDIF
.ELSEIF ax==MI_USENUMBERS		
	invoke	CheckMenuItem, hMenu, MI_USEFILE, MF_UNCHECKED
	invoke	CheckMenuItem, hMenu, MI_USENUMBERS, MF_CHECKED
	invoke	CheckMenuItem, hMenu, MI_USESTANDARD, MF_UNCHECKED
	invoke	SendMessage, hToolbar, TB_CHECKBUTTON, MI_USENUMBERS, TRUE
	invoke	SetBitmap, hWnd, IMAGETYPE_NUMBERS
	invoke	InvalidateRect, hWnd, NULL, FALSE
.ELSEIF ax==MI_USESTANDARD		
	invoke	CheckMenuItem, hMenu, MI_USEFILE, MF_UNCHECKED
	invoke	CheckMenuItem, hMenu, MI_USENUMBERS, MF_UNCHECKED
	invoke	CheckMenuItem, hMenu, MI_USESTANDARD, MF_CHECKED
	invoke	SendMessage, hToolbar, TB_CHECKBUTTON, MI_USESTANDARD, TRUE
	invoke	SetBitmap, hWnd, IMAGETYPE_STANDARD
	invoke	InvalidateRect, hWnd, NULL, FALSE
;-------------------------------------------------------------------------------
; Color Scheme
;-------------------------------------------------------------------------------
.ELSEIF ax==MI_COLORBLUE
	invoke	SetColors, eax
	invoke	CheckMenuItem, hMenu, MI_COLORRED, MF_UNCHECKED
	invoke	CheckMenuItem, hMenu, MI_COLORBLUE, MF_CHECKED
	invoke	CheckMenuItem, hMenu, MI_COLORGREEN, MF_UNCHECKED
	invoke	CheckMenuItem, hMenu, MI_COLORUGLY, MF_UNCHECKED
	invoke	SetBitmap, hWnd, CurImageType
	invoke	InvalidateRect, hWnd, NULL, FALSE
.ELSEIF ax==MI_COLORRED
	invoke	SetColors, eax
	invoke	CheckMenuItem, hMenu, MI_COLORRED, MF_CHECKED
	invoke	CheckMenuItem, hMenu, MI_COLORBLUE, MF_UNCHECKED
	invoke	CheckMenuItem, hMenu, MI_COLORGREEN, MF_UNCHECKED
	invoke	CheckMenuItem, hMenu, MI_COLORUGLY, MF_UNCHECKED
	invoke	SetBitmap, hWnd, CurImageType
	invoke	InvalidateRect, hWnd, NULL, FALSE
.ELSEIF ax==MI_COLORGREEN
	invoke	SetColors, eax
	invoke	CheckMenuItem, hMenu, MI_COLORRED, MF_UNCHECKED
	invoke	CheckMenuItem, hMenu, MI_COLORBLUE, MF_UNCHECKED
	invoke	CheckMenuItem, hMenu, MI_COLORGREEN, MF_CHECKED
	invoke	CheckMenuItem, hMenu, MI_COLORUGLY, MF_UNCHECKED
	invoke	SetBitmap, hWnd, CurImageType
	invoke	InvalidateRect, hWnd, NULL, FALSE
.ELSEIF ax==MI_COLORUGLY
	invoke	SetColors, eax
	invoke	CheckMenuItem, hMenu, MI_COLORRED, MF_UNCHECKED
	invoke	CheckMenuItem, hMenu, MI_COLORBLUE, MF_UNCHECKED
	invoke	CheckMenuItem, hMenu, MI_COLORGREEN, MF_UNCHECKED
	invoke	CheckMenuItem, hMenu, MI_COLORUGLY, MF_CHECKED
	invoke	SetBitmap, hWnd, CurImageType
	invoke	InvalidateRect, hWnd, NULL, FALSE
;-------------------------------------------------------------------------------
; New game
;-------------------------------------------------------------------------------
.ELSEIF ax==MI_NEWGAME
	invoke	NewGame, hWnd
;-------------------------------------------------------------------------------
; Open Bitmap
;-------------------------------------------------------------------------------
.ELSEIF ax==MI_OPENBITMAP
	invoke	GetOpenFileName, ADDR BitmapOFN
	.IF		eax!=NULL
		invoke	ProcessMenuItems, hWnd, MI_USEFILE
	.ENDIF
.ENDIF
ret
ProcessMenuItems endp

SetColors proc uses ebx cType:DWORD
	invoke	DeleteObject, hBackgroundColor
	invoke	DeleteObject, hTileColor
; ebx = background
; edx = text
; eax = tile
	mov		eax, cType
	.IF		ax==MI_COLORRED
		mov		eax, 00000A0h
		mov		edx, 00000FFh
		mov		ebx, 05050E0h
	.ELSEIF ax==MI_COLORBLUE
		mov		eax, 0FF8080h
		mov		edx, 0800000h
		mov		ebx, 0FF8000h
	.ELSEIF ax==MI_COLORGREEN
		mov		eax, 000A000h
		mov		edx, 000FF00h
		mov		ebx, 050E050h
	.ELSEIF ax==MI_COLORUGLY
		mov		eax, 0FF00FFh
		mov		edx, 000FF00h
		mov		ebx, 00000FFh
	.ENDIF
	mov		TextColor, edx
	
	invoke	CreateSolidBrush, eax
	mov		hTileColor, eax
		
	invoke	CreateSolidBrush, ebx
	mov		hBackgroundColor, eax
ret
SetColors endp
;================================================================================
;							Check If valid bitmap
;================================================================================

CheckIfValidBitmap proc uses edi hWnd:DWORD, pMem:DWORD, FileSize:DWORD
	 mov	edi, pMem
	 mov	ax, word ptr [edi]
	 .IF	ax!="MB"
	 	xor 	eax, eax
	 	ret
	 .ENDIF
	 
	 mov	eax, dword ptr [edi+2]
	 .IF	eax!=FileSize
	 	xor		eax, eax
	 	ret
	 .ENDIF
	 
	 mov	eax, dword ptr [edi+0Eh]
	 .IF	eax!=28h
	 	xor		eax, eax
	 	ret
	 .ENDIF
	 mov	eax, dword ptr [edi+12h]
	 mov	ecx, dword ptr [edi+16h]
	 .IF	eax!=200 || ecx!=200
	 	mov		eax, 2
	 	ret
	 .ENDIF
	 
xor eax,eax
inc eax
ret
CheckIfValidBitmap endp
;================================================================================
;							OpenBitmap
;================================================================================
OpenBitmap		proc	uses edi esi	hWnd:DWORD
LOCAL	hFile:DWORD
LOCAL	FileSize:DWORD
LOCAL	hMem:DWORD
LOCAL 	pMem:DWORD
LOCAL	BytesRead:DWORD


	invoke	DeleteObject, hImage
	invoke	CreateFile, ADDR OFN_file, GENERIC_READ, FILE_SHARE_READ,\
			NULL, OPEN_EXISTING, NULL, NULL
	.IF		eax==INVALID_HANDLE_VALUE
		MSGBOX 	"Error: Could not open bitmap file."
		invoke	ProcessMenuItems, hWnd, MI_USESTANDARD	;fake menu press
		ret
	.ENDIF
	mov		hFile, eax
	
	invoke	GetFileSize, hFile, NULL
	mov		FileSize, eax

	invoke	GlobalAlloc, GMEM_MOVEABLE, eax
	mov		hMem, eax
	invoke	GlobalLock, eax
	mov		pMem, eax

	invoke	ReadFile, hFile, pMem, FileSize, ADDR BytesRead, NULL

	mov		ecx, FileSize
	.IF		BytesRead!=ecx || eax==NULL
		MSGBOX 	"Error: Failed reading from bitmap file."
		invoke	ProcessMenuItems, hWnd, MI_USESTANDARD	;fake menu press
		jmp		@ob_exit1
	.ENDIF
	
	invoke	CheckIfValidBitmap, hWnd, pMem, FileSize
	.IF		eax==NULL
		MSGBOX	"ERROR: Bitmap is invalid."
		invoke	ProcessMenuItems, hWnd, MI_USESTANDARD	;fake menu press
	.ELSEIF eax==1 
		mov		ecx, pMem
		mov		edx, ecx
		mov		edx, dword ptr [edx + 0Ah]
		add		edx, ecx
		add		ecx, 0Eh ; Bitmapheader


		invoke	CreateDIBitmap, ImageDC, ecx, CBM_INIT,\
					edx, ecx, DIB_RGB_COLORS	
		mov		hImage, eax
	.ELSEIF		eax==2
			MSGBOX	"ERROR: This bitmap is not 200x200 pixels."
			mov		eax, offset OFN_file
			mov		byte ptr [eax], 0
			invoke	ProcessMenuItems, hWnd, MI_USESTANDARD	;fake menu press
	.ENDIF
@ob_exit1:
	invoke	GlobalUnlock, hMem
	invoke	GlobalFree, hMem
	invoke	CloseHandle, hFile

ret
OpenBitmap		endp

end start

